<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_CRON")) return;
define("_ECRIRE_INC_CRON", "1");

// Taches de fond

//
// Envoi du mail quoi de neuf
//
if (!$flag_ecrire AND (lire_meta('quoi_de_neuf') == 'oui') AND ($jours_neuf = lire_meta('jours_neuf'))
    AND ($adresse_neuf = lire_meta('adresse_neuf')) AND (time() - ($majnouv = lire_meta('majnouv'))) > 3600 * 24 * $jours_neuf)
{

	if (timeout('quoide_neuf')) 
	  {
		ecrire_meta('majnouv', time());
		ecrire_metas();
		unset ($mail_nouveautes);
		unset ($sujet_nouveautes);
		$page= calcule_page('nouveautes',
				    '',
				    array('date' => date('Y-m-d H:i:s', $majnouv)),
				    '',
				    '');
		eval ('?' . '>' . $page['texte']);
		if ($mail_nouveautes) {
			spip_log("envoi mail nouveautes");
			include_ecrire('inc_mail.php3');
			envoyer_mail($adresse_neuf, $sujet_nouveautes, $mail_nouveautes);
		} else
			spip_log("envoi mail nouveautes : pas de nouveautes");
	}
}

// recalcul des rubriques publiques (cas de la publication post-datee)
if ((time()-lire_meta('calcul_rubriques') > 3600) AND timeout('calcul_rubriques')) {
	include_ecrire('inc_meta.php3');
	ecrire_meta('calcul_rubriques', time());
	ecrire_metas();
	include_ecrire('inc_rubriques.php3');
	calculer_rubriques();
}

//
// Archivage des statistiques du site public
//

if (lire_meta("activer_statistiques") != "non") {
	if (timeout(false, false))	// no lock, no action
	{
		// Conditions declenchant un eventuel calcul des stats
		if ((lire_meta('calculer_referers_now') == 'oui')
		OR (date("Y-m-d") <> lire_meta("date_statistiques"))
		OR (time() - lire_meta('date_stats_popularite') > 1800)) {
			include_local ("inc-stats.php3");
			ecrire_stats();
		}
	}
}

//  une entre nulle dans les index est une demande d'indexation
// (cf les fonctions index_article, indexer_mot etc)
if ((timeout('indexation')) && (lire_meta('activer_moteur') == 'oui') && $db_ok) {
  $r = spip_fetch_array(spip_query("
SELECT	id_article
FROM	spip_index_articles 
WHERE	points=0
LIMIT 1
"));
  if ($r['id_article'])
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('article', $r['id_article']);
    }
  else {
  $r = spip_fetch_array(spip_query("
SELECT	id_auteur
FROM	spip_index_auteurs 
WHERE	points=0
LIMIT 1
"));
  if ($r['id_auteur'])
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('auteur', $r['id_auteur']);
    }
  else {
  $r = spip_fetch_array(spip_query("
SELECT	id_breve
FROM	spip_index_breves 
WHERE	points=0
LIMIT 1
"));
  if ($r['id_breve'])
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('breve', $r['id_breve']);
    }
  else {
  $r = spip_fetch_array(spip_query("
SELECT	id_mot
FROM	spip_index_mots 
WHERE	points=0
LIMIT 1
"));
  if ($r['id_mot'])
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('mot', $r['id_mot']);
    }
  else {
  $r = spip_fetch_array(spip_query("
SELECT	id_rubrique
FROM	spip_index_rubriques 
WHERE	points=0
LIMIT 1
"));
  if ($r['id_rubrique'])
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('rubrique', $r['id_rubrique']);
    }
  }}}}
}


//
// Mise a jour d'un (ou de zero) site syndique
//

if ($db_ok AND lire_meta("activer_syndic") != "non") {
	if (timeout()) {
                include_ecrire("inc_sites.php3");
                executer_une_syndication();
                if (lire_meta('activer_moteur') == 'oui') {
                        include_ecrire("inc_index.php3");
                        executer_une_indexation_syndic();
                }
	}
}


// Effacement de la poubelle (documents supprimes)
//

if (file_exists($fichier_poubelle = "ecrire/data/.poubelle")) {
        if (timeout('poubelle')) {
                if ($s = sizeof($suite = file($fichier_poubelle))) {
                        $s = $suite[$n = rand(0, $s)];
                        $s = trim($s);
                        include_ecrire("inc_connect.php3");
                        if ($db_ok) {
                           // Verifier qu'on peut vraiment effacer le fichier
                                $query = "SELECT id_document FROM spip_documents 
WHERE fichier='$s'";
                                $result = spip_query($query);
                                if (spip_num_rows($result) OR !ereg('^IMG/', $s) 
OR strpos($s, '..')) {
                                        spip_log("Tentative d'effacement interdit
: $s");
                                }
                                else {
                                        @unlink($s);
                                }
                                unset($suite[$n]);
                                $f = fopen($fichier_poubelle, 'wb');
                                fwrite($f, join("", $suite));
                                fclose($f);
                        }
                }
                else @unlink($fichier_poubelle);
        }
}

?>
